<script lang="ts" setup>
import { onMounted, ref, unref } from 'vue';

import { useVbenModal } from '@vben/common-ui';

import { message } from 'ant-design-vue';

import { useVbenForm } from '#/adapter/form';
import { TenantApi } from '#/api';

import { formOptions } from '../data.config';

defineOptions({
  name: 'TenantEdit',
});
const emit = defineEmits(['success']);
const modelRef = ref<Record<string, any>>({});
const isUpdate = ref(true);

const [Form, { validate, setValues, getValues }] = useVbenForm({
  showDefaultActions: false,
  ...formOptions,
});

const [Modal, { close, setState, getData }] = useVbenModal({
  fullscreenButton: false,
  draggable: true,
  onCancel() {
    close();
  },
  onConfirm: async () => {
    try {
      const { valid } = await validate();
      if (valid) {
        const values = await getValues();
        setState({ confirmLoading: true });
        const postParams = unref(modelRef);
        Object.assign(postParams, values);
        await (unref(isUpdate)
          ? TenantApi.editDetail(postParams as TenantApi.RecordItem)
          : TenantApi.addDetail(postParams as TenantApi.BasicRecordItem));
        message.success('操作成功');

        close();
        emit('success');
      }
    } catch {
      message.error('操作失败');
    } finally {
      setState({ confirmLoading: false });
    }
  },
  onOpenChange: async (isOpen: boolean) => {
    if (isOpen) {
      setState({ loading: true });
      const data = getData<Record<string, any>>();
      isUpdate.value = !!data.isUpdate;
      modelRef.value = { ...data.baseData };
      setState({ title: unref(isUpdate) ? '编辑租户' : '新增租户' });

      if (unref(isUpdate)) {
        const entity = await TenantApi.getDetail(data.baseData.id);
        modelRef.value = { ...entity };
        setValues(entity);
      }
      setState({ loading: false });
    }
  },
  title: '新增租户',
});

onMounted(async () => {});
</script>
<template>
  <Modal class="w-[1000px]">
    <Form />
  </Modal>
</template>
